org.apache.lucene.analysis.de

## Class GermanAnalyzer

- java.lang.Object
- - org.apache.lucene.analysis.Analyzer
  - - org.apache.lucene.analysis.util.StopwordAnalyzerBase
    - - org.apache.lucene.analysis.de.GermanAnalyzer

All Implemented Interfaces:
  Closeable, AutoCloseable

    public final class GermanAnalyzer
    extends StopwordAnalyzerBase

`Analyzer` for German language.

Supports an external list of stopwords (words that will not be indexed at all) and an external list of exclusions (word that will not be stemmed, but indexed). A default set of stopwords is used unless an alternative list is specified, but the exclusion list is empty by default.

You must specify the required `Version` compatibility when creating GermanAnalyzer:

- As of 3.6, GermanLightStemFilter is used for less aggressive stemming.
- As of 3.1, Snowball stemming is done with SnowballFilter, and Snowball stopwords are used by default.
- As of 2.9, StopFilter preserves position increments

NOTE: This class uses the same `Version` dependent settings as `StandardAnalyzer`.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.lucene.analysis.Analyzer

`Analyzer.GlobalReuseStrategy, Analyzer.PerFieldReuseStrategy, Analyzer.ReuseStrategy, Analyzer.TokenStreamComponents`

### Field Summary

Fields
`static String` `DEFAULT_STOPWORD_FILE` File containing default German stopwords.

### Fields inherited from class org.apache.lucene.analysis.util.StopwordAnalyzerBase

`matchVersion, stopwords`

### Constructor Summary

Constructors
Constructor and Description
`GermanAnalyzer(Version matchVersion)` Builds an analyzer with the default stop words: `getDefaultStopSet()`.
`GermanAnalyzer(Version matchVersion, CharArraySet stopwords)` Builds an analyzer with the given stop words
`GermanAnalyzer(Version matchVersion, CharArraySet stopwords, CharArraySet stemExclusionSet)` Builds an analyzer with the given stop words

### Method Summary

Methods
`protected Analyzer.TokenStreamComponents` `createComponents(String fieldName, Reader reader)` Creates `Analyzer.TokenStreamComponents` used to tokenize all the text in the provided `Reader`.
`static CharArraySet` `getDefaultStopSet()` Returns a set of default German-stopwords

### Methods inherited from class org.apache.lucene.analysis.util.StopwordAnalyzerBase

`getStopwordSet, loadStopwordSet, loadStopwordSet, loadStopwordSet`

### Methods inherited from class org.apache.lucene.analysis.Analyzer

`close, getOffsetGap, getPositionIncrementGap, initReader, tokenStream`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_STOPWORD_FILE

    public static final String DEFAULT_STOPWORD_FILE

File containing default German stopwords.

See Also:
  Constant Field Values

### Constructor Detail

#### GermanAnalyzer

    public GermanAnalyzer(Version matchVersion)

Builds an analyzer with the default stop words: `getDefaultStopSet()`.

#### GermanAnalyzer

    public GermanAnalyzer(Version matchVersion,
                  CharArraySet stopwords)

Builds an analyzer with the given stop words

Parameters:
  `matchVersion` - lucene compatibility version
  `stopwords` - a stopword set

#### GermanAnalyzer

    public GermanAnalyzer(Version matchVersion,
                  CharArraySet stopwords,
                  CharArraySet stemExclusionSet)

Builds an analyzer with the given stop words

Parameters:
  `matchVersion` - lucene compatibility version
  `stopwords` - a stopword set
  `stemExclusionSet` - a stemming exclusion set

### Method Detail

#### getDefaultStopSet

    public static final CharArraySet getDefaultStopSet()

Returns a set of default German-stopwords

Returns:
  a set of default German-stopwords

#### createComponents

    protected Analyzer.TokenStreamComponents createComponents(String fieldName,
                                                  Reader reader)

Creates `Analyzer.TokenStreamComponents` used to tokenize all the text in the provided `Reader`.

Specified by:
  `createComponents` in class `Analyzer`
Returns:
  `Analyzer.TokenStreamComponents` built from a `StandardTokenizer` filtered with `StandardFilter`, `LowerCaseFilter`, `StopFilter` , `KeywordMarkerFilter` if a stem exclusion set is provided, `GermanNormalizationFilter` and `GermanLightStemFilter`